#!/bin/bash

# Frontend setup
if [ -d "frontend-react" ]; then
  echo "Setting up frontend-react..."
  cd frontend-react
  #npm install
  deno install --allow-scripts
  cd ..
else
  echo "frontend-react directory not found, skipping..."
fi

# Dart backend setup
if [ -d "backend_dart" ]; then
  echo "Setting up backend_dart..."
  cd backend_dart
  dart pub get
  cd ..
else
  echo "backend_dart directory not found, skipping..."
fi

# Go backend setup
if [ -d "backend-go" ]; then
  echo "Setting up backend-go..."
  cd backend-go
  go mod tidy
  cd ..
else
  echo "backend-go directory not found, skipping..."
fi

sudo chmod 600 /home/vscode/.ssh/* && sudo chown $USER:$USER /home/vscode/.ssh/*
#git config --global user.name 'Jean Avril' && git config --global user.email 'jean@jeanavril.com'