# Concept & Ideas
## 1 Tools and Packages
### 1.1 Dart 
- Functional Programming: FPDart
- SQL ORM: Prisma Dart
  - https://prisma.pub/ 
### 1.2 Go
- Functional Programming: https://github.com/IBM/fp-go
  - Docu: https://pkg.go.dev/github.com/IBM/fp-go
### 1.3 TS
- Functional Programming: fp-ts Package
  - https://github.com/gcanti/fp-ts
- Engine: Deno


## 2 Steps
1. Install Prisma on Dart and Go
   1. https://prisma.pub/getting-started/setup.html
   2. https://goprisma.org/docs/getting-started/quickstart#manual-setup
2. Build ORM
   1. GO: go run github.com/steebchen/prisma-client-go generate
   2. Dart: pnpx prisma generate
3. Push Schema to DB
   1. go run github.com/steebchen/prisma-client-go db push
4. Run Backends
   1. Adjust config in necessary
   2. Inside the GoBackend folder run
      go run cmd/actatempus/main.go
   3. Inside the DartBackend folder run
      dart run .\bin\backend_dart.dart 