"use client";

import LocaleSwitcher from "../Navigation/LocaleSwitcher";
import NavigationBar from "../Navigation/NavigationBar";
import { ThemeSwitcher } from "../Navigation/ThemeSwitcher";

const Header: React.FC = () => {
	return (
		<header className="flex justify-between items-center p-4 bg-white dark:bg-gray-900 shadow-md">
			{/* Logo */}
			<div className="text-xl font-bold text-gray-900 dark:text-white">
				ActaTempus
			</div>
			<NavigationBar />
			{/* Theme Switcher Dropdown */}
			<div className="flex items-center">
				<ThemeSwitcher />
				<LocaleSwitcher />
			</div>
		</header>
	);
};

export default Header;
